<?php

	/**
	 * Mit diesem Modul ist es möglich einen mindest Bestellwert festzulegen
	 * @author Daschmi
	 */
	class wpsg_mod_minrequest extends wpsg_mod_basic 
	{
		
		var $lizenz = 1;
		var $id = 3070;
		var $hilfeURL = 'http://wpshopgermany.maennchen1.de/?p=660915';
		var $version = "4.4.9";
		
		public function __construct()
		{
			
			parent::__construct();
				
			$this->name = __('Mindestbestellwert', 'wpsg');
			$this->group = __('Bestellung', 'wpsg');
			$this->desc = __('Erlaubt das festlegen eines Mindest- und Maximalbestellwertes.', 'wpsg');
			
		} // public function __construct()
		
		public function install()
		{
		    
		    require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php');
		    
		    /*
		     * Produkt Tabelle erweitern
		     */
		    $sql = "CREATE TABLE ".WPSG_TBL_PRODUCTS." (
		   		wpsg_mod_minrequest_product_activ INT(11) NOT NULL,
                wpsg_mod_minrequest_value DOUBLE(10,2) NOT NULL,
				wpsg_mod_minrequest_valuemax DOUBLE(10,2) NOT NULL
		   	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
		    
		    dbDelta($sql);		    
		    
		} // public function install()
		
		public function settings_edit()
		{

			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_minrequest/settings_edit.phtml');
			
		} // public function settings_edit()
		
		public function settings_save()
		{
			
		    $this->shop->update_option('wpsg_mod_minrequest_productamount', $_REQUEST['wpsg_mod_minrequest_productamount'], false, false, WPSG_SANITIZE_CHECKBOX);
		    $this->shop->update_option('wpsg_mod_minrequest_productamount_max', $_REQUEST['wpsg_mod_minrequest_productamount_max'], false, false, WPSG_SANITIZE_CHECKBOX);
		    $this->shop->update_option('wpsg_mod_minrequest_basketamount', $_REQUEST['wpsg_mod_minrequest_basketamount'], false, false, WPSG_SANITIZE_FLOAT);
		    $this->shop->update_option('wpsg_mod_minrequest_basketmaxamount', $_REQUEST['wpsg_mod_minrequest_basketmaxamount'], false, false, WPSG_SANITIZE_FLOAT);
			
		} // public function settings_save()
		
		/*
		 * zeigt die Staffelpreise im Produktbackend an
		 */
		public function product_addedit_content(&$product_content, &$product_data) {
		    
		    if (wpsg_isSizedInt($product_data['id'])) {
		        
		        $product_data = wpsg_array_merge($product_data, $this->db->fetchRow("
						SELECT
							`wpsg_mod_minrequest_value`,`wpsg_mod_minrequest_valuemax`, `wpsg_mod_minrequest_product_activ`
						FROM
							`".WPSG_TBL_PRODUCTS."`
						WHERE
							`id` = '".wpsg_q($product_data['id'])."'
					"));

			    $product_data['arMinrequest_value'] = explode(',', $this->shop->get_option('wpsg_mod_minrequest_value'));
			    $product_data['arMinrequest_valuemax'] = explode(',', $this->shop->get_option('wpsg_mod_minrequest_valuemax'));

	            $product_content['price']['content'] .= $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_minrequest/produkt_addedit_allgemein.phtml', false);

		    }
		    
		}//public function product_addedit_content(&$product_content, &$product_data)
		
		
		public function produkt_edit_allgemein(&$produkt_data) {

		    $this->shop->view['wpsg_mod_minrequest']['product_activ'] = $produkt_data['wpsg_mod_minrequest_product_activ']??'0';
		    $this->shop->view['wpsg_mod_minrequest']['value'] = $produkt_data['wpsg_mod_minrequest_value']??'';
		    $this->shop->view['wpsg_mod_minrequest']['valuemax'] = $produkt_data['wpsg_mod_minrequest_valuemax']??'';
		    
		    //$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_minquantity/produkt_edit_allgemein.phtml');
		    
		} // public function produkt_edit_allgemein(&$produkt_data)
		
		public function produkt_save_before(&$produkt_data) {

			wpsg_checkRequest('wpsg_mod_minrequest_product_activ', [WPSG_SANITIZE_CHECKBOX, ['allowEmpty' => true]], __('Minimalbestand Aktiv'), $produkt_data, $_REQUEST['wpsg_mod_minrequest']['product_activ']);
			wpsg_checkRequest('wpsg_mod_minrequest_value', [WPSG_SANITIZE_FLOAT, ['allowEmpty' => true]], __('Minimalbestand Aktiv'), $produkt_data, $_REQUEST['wpsg_mod_minrequest']['value']);
			wpsg_checkRequest('wpsg_mod_minrequest_valuemax', [WPSG_SANITIZE_FLOAT, ['allowEmpty' => true]], __('Minimalbestand Aktiv'), $produkt_data, $_REQUEST['wpsg_mod_minrequest']['valuemax']);

		} // public function produkt_save_before(&$produkt_data)
		
		public function checkBasket(&$bNoErrorBasket) 
		{ 
 
			if (!$this->_checkBasketMin($this->shop->cache->getShopBasketArray()))
			{

				$this->shop->addFrontendError(wpsg_translate(
					__('Der Mindestbestellwert von #1# #2# wurde nicht erreicht.', 'wpsg'),
					wpsg_ff($this->shop->get_option('wpsg_mod_minrequest_basketamount')),
					$this->shop->get_option('wpsg_currency'))	
				);
				
				$bNoErrorBasket = false; 
				
			}		

			if (!$this->_checkBasketMax($this->shop->cache->getShopBasketArray()))
			{
			
				$this->shop->addFrontendError(wpsg_translate(
					__('Der Maximalbestellwert von #1# #2# wurde überschritten.', 'wpsg'),
					wpsg_ff($this->shop->get_option('wpsg_mod_minrequest_basketmaxamount')),
					$this->shop->get_option('wpsg_currency')
				));
			
				$bNoErrorBasket = false;
			
			}
			
		} // public function checkBasket(&$error, &$arBasket) 
		
		public function checkCheckout(&$state, &$error, &$arCheckout)
		{
		 
			// Beim speichern des Kundenprofils nicht prüfen
			if (isset($_REQUEST['wpsg_mod_kundenverwaltung_save']) || isset($_REQUEST['wpsg_mod_kundenverwaltung_register'])) return;
			
			// Im Checkout ist es logischer umgesetzt und $error wird im Fehlerfall true !
			
			$bNoErrorBasket = true;			
			$this->checkBasket($bNoErrorBasket);
			
			if ($bNoErrorBasket === false) $error = true;
			
		} // public function checkCheckout(&$state, &$error, &$arCheckout)
				
		/* Modulfunktionen */
		
		/**
		 * Überprüft den Mindestbestellwert im Warenkorb und gibt true oder false zurück
		 * @param \Array $arBasket
		 * @return \Boolean
		 */
		private function _checkBasketMin($arBasket)
		{
			 
			$check_amount = $arBasket['sum']['preis_brutto'];
			$minAmount = wpsg_tf($this->shop->get_option('wpsg_mod_minrequest_basketamount'));
			
			$bReturn = true;
			
			if ($check_amount < $minAmount)
			{
			
				$bReturn = false;
			
			}
			
			return $bReturn;
			
		} // private function _checkBasketMin($arBasket)
		
		/**
		 * Überprüft den Warenkorb auf den Maximalbestellwert		
		 */
		private function _checkBasketMax($arBasket)
		{
			
			$check_amount = $arBasket['sum']['preis_brutto'];			
			$maxAmount = wpsg_tf($this->shop->get_option('wpsg_mod_minrequest_basketmaxamount'));
				
			$bReturn = true;
							
			if (wpsg_isSizedDouble($maxAmount) && $check_amount > $maxAmount)
			{
			
				$bReturn = false;
			
			}
				
			return $bReturn;
			
		} // private function _checkBasketMax($arBasket)
		
		
		/**
		 * Gibt den Mindestbestellwert anhand der ProduktID zurück
		 * @param int $product_id
		 * @return boolean
		 */
		public function getMinRequest($product_id)
		{
		    
		    $product_data = $this->shop->cache->loadProduct($product_id);
		    
		    return $product_data['wpsg_mod_minrequest_value'];
		    
		} // public function getMinRequest($product_id)
		
		/**
		 * Gibt den Maximalbestellwert anhand der ProduktID zurück
		 * @param int $product_id
		 * @return boolean
		 */
		public function getMaxRequest($product_id)
		{
		    
		    $product_data = $this->shop->cache->loadProduct($product_id);
		    
		    return $product_data['wpsg_mod_minrequest_valuemax'];
		    
		} // public function getMaxRequest($product_id)
		
	} // class wpsg_mod_minrequest extends wpsg_mod_basic

?>